<?php
// echo '<pre>';
// print_r($GLOBALS);
// exit;

include('./PHPExcel/PHPExcel.php');
include('./config.php');
$workTime = $summerWorkTime;
if('winter' == $_POST['workType']) $workTime = $winterWorkTime;

# 功能函数
function getDayRs($str='',$isMonday = 0,$dept='中心',$spec='否',$debug=0){
	global $workTime;
	if(!array_key_exists($dept, $workTime)) exit('ERROR: Invalid department name.');
	$amStart = $workTime[$dept]['amStart'];
	$amEnd   = $workTime[$dept]['amEnd'];
	$pmStart = $workTime[$dept]['pmStart'];
	$pmEnd   = $workTime[$dept]['pmEnd'];
	$maxLateTime = 3600; // 最大迟到和早退时间：秒
	$rs = array('AM'=>'','PM'=>'');
	$str = trim($str);
	$str = preg_replace('/\s+/', '#',$str);
	$record = explode('#', $str);
	// $record = array_unique($record); // 1分钟内多条记录合为1条(不使用该功能的原因是允许中午1分钟内按两次：一次下班，一次上班)
	$totalRecord = count($record);
	if($totalRecord < 2) return $rs; // 只有一条记录时按当天未上班计

	if(!$amStart) $amStart = strtotime('08:20');
	if(!$amEnd  ) $amEnd   = strtotime('12:00');
	if(!$pmStart) $pmStart = strtotime('14:00');
	if(!$pmEnd  ) $pmEnd   = strtotime('18:00');
	if($debug){
		echo '$amStart: '.date('H:i',$amStart).'<br />';
		echo '$amEnd  : '.date('H:i',$amEnd  ).'<br />';
		echo '$pmStart: '.date('H:i',$pmStart).'<br />';
		echo '$pmEnd  : '.date('H:i',$pmEnd  ).'<br />';
	}
	if('中心' == $dept && $isMonday){ // 融科周一提前10分钟
		$amStart -= 600;
	}
	$amRecord = $noonRecord = $pmRecord = array();
	$beforeAm = $noon = $afterPm = 0; // 早上、中午、晚上的打卡次数


	// 筛选记录到 上午 中午 下午
	foreach ($record as $r) {
		$ts = strtotime($r);
		if($ts < $amEnd) {
			if($ts <= $amStart){ // 只记录一个上班前的记录
				if(0 == $beforeAm){
					$amRecord[] = $r;
				}
				$beforeAm++;
			}else{
				$amRecord[] = $r;
			}
		}
		if($ts >= $amEnd && $ts <= $pmStart){
			if($noon <= 2) $noonRecord[] = $r; // 只记录2个中午的记录
			$noon++;
		}
		if($ts > $pmStart){
			if($ts >= $pmEnd){ // 只记录一个下班后的记录
				if(0 == $afterPm){
					$pmRecord[] = $r;
				}
				$afterPm++;
			}else{
				$pmRecord[] = $r;
			}
		}
	}

	if($totalRecord == $noon)     return $rs; // 全部是中午打的卡：无视
	if($totalRecord == $beforeAm) return $rs; // 全部是上班前打的卡：无视
	if($totalRecord == $afterPm)  return $rs; // 全部是下班后的卡：无视
	// if($totalRecord == count($amRecord)) { // 全部是上午打的卡：无视
	// 	if(!$beforeAm) return $rs;
	// }
	// if($totalRecord == count($pmRecord)) { // 全部是下午打的卡：无视
	// 	if(!$afterPm) return $rs;
	// }

	// 将中午的记录分给上午和下午
	if(!empty($noonRecord)){
		$i = 1;
		foreach ($noonRecord as $r) {
			if(1 == $i && !empty($amRecord)) // 第一条分给上午，第2条给下午，其它的扔掉
				$amRecord[] = $r;
			else
				array_unshift($pmRecord,$r);
			$i++;
			if($i > 2) break;
		}
	}

	// t:total s:start e:end
	if($amRecord){
		$t = count($amRecord);
		$s = strtotime($amRecord[0]);
		$e = strtotime($amRecord[$t-1]);
		if(0 == $t){
			$rs['AM'] = '';
		}else if(1 == $t){
			if($s <= $amStart){
				if( count($pmRecord) == 1 && isset($pmRecord[0]) && strtotime($pmRecord[0]) < $pmEnd)
					$rs['AM'] .= '√'; // 上午打一次，下午在下班前打了一次
				else $rs['AM'] .= '未退';
			}
			if($s >  $amStart && $s < $amEnd) $rs['AM'] .= ''; // 迟到未退
			if($s >= $amEnd)   $rs['AM'] .= ''; // 未签 或 中午打了N次，上午没上班
		}else{
			// echo __LINE__;
			// echo '$s: '.date('H:i',$s).'<br />';
			// echo '$e: '.$e.'<br />';
			// echo '$+: '.date('H:i',$amStart + $maxLateTime).'<br />';
			if($s > $amStart && $s <= $amStart + $maxLateTime) $rs['AM'] .= '迟到';
			if($e < $amEnd   && $e >= $amEnd   - $maxLateTime) $rs['AM'] .= '早退';
			if($s > $amStart + $maxLateTime) $rs['AM'] = '休'; // 太晚签到（迟到超过1小时）
			if($e < $amEnd   - $maxLateTime) $rs['AM'] = '休'; // 太早签退（距离下班超过1小时）
			if(empty($rs['AM']))   $rs['AM'] .= '√';
		}
	}
	if($pmRecord){
		$t = count($pmRecord);
		$s = strtotime($pmRecord[0]);
		$e = strtotime($pmRecord[$t-1]);
		if(0 == $t){
			$rs['PM'] = '';
		}else if(1 == $t){
			if($s >  $pmStart && count($noonRecord) >= 2)
				$rs['PM'] = ''; // 迟到未退
			if($s >= $pmEnd)   $rs['PM'] = '未签'; // 不能和上条行换位
			if($s <= $pmStart) $rs['PM'] = ''; // 未退 或 中午多次下午未上班
		}else{
			if($s > $pmStart && $s <= $pmStart + $maxLateTime)    $rs['PM'] .= '迟到';
			if($e < $pmEnd   && $e >= $pmEnd   - $maxLateTime)    $rs['PM'] .= '早退';
			if($s > $pmStart + $maxLateTime) $rs['PM'] = '休'; // 太晚签到（迟到超过1小时）
			if($e < $pmEnd   - $maxLateTime) $rs['PM'] = '休'; // 太早签退（距离下班超过1小时）
			if(empty($rs['PM'])) $rs['PM'] .= '√';
		}
	}

	// echo '<'.'pre>';
	// echo '$record ';print_r($record);
	// echo '$amRecord ';print_r($amRecord);
	// echo '$noonRecord ';print_r($noonRecord);
	// echo '$pmRecord ';print_r($pmRecord);

	if(empty($rs['AM'])) $rs['AM'] = '休';
	if(empty($rs['PM'])) $rs['PM'] = '休';
	return $rs;
}

// echo $str = '08:14 12:00 13:19 18:06';
// echo '<pre'.'>';
// $rs = getDayRs($str);
// print_r($rs);
// exit;

# 表头的样式（thead）
$thStyle = array(
	'font' => array(
		// 'bold' => true,
		'color'=>array('argb' => '00000000'),
	),
	'alignment' => array(
		'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
		'vertical'   => PHPExcel_Style_Alignment::VERTICAL_CENTER,
	),
	'borders' => array(
		'allborders' => array(
			//'style' => PHPExcel_Style_Border::BORDER_THICK,//边框是粗的
			'style' => PHPExcel_Style_Border::BORDER_THIN,//细边框
			// 'color' => array('argb' => 'FFFF0000'),
		),
	),
);
# 数据单元格的样式
$tdStyle = array(
	'alignment' => array(
		'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
		'vertical'   => PHPExcel_Style_Alignment::VERTICAL_CENTER,
	),
	// 'borders' => array(
	// 	'allborders' => array(
	// 		//'style' => PHPExcel_Style_Border::BORDER_THICK,//边框是粗的
	// 		'style' => PHPExcel_Style_Border::BORDER_THIN,//细边框
	// 		// 'color' => array('argb' => 'FFFF0000'),
	// 	),
	// ),
);
$lateStyle = array( // 迟到
	'font' => array(
		'bold' => true,
		'color' => array('rgb' => 'FF0000'),
		// 'size' => 15,
		// 'name' => 'Verdana'
	)
);
$noSignStyle = array( // 未签到
	'font' => array(
		'bold' => true,
		'color' => array('rgb' => '0000FF'), // 粉
		// 'size' => 15,
		// 'name' => 'Verdana'
	)
);
$noSignOffStyle = array( // 未签退
	'font' => array(
		'bold' => true,
		'color' => array('rgb' => '00FFFF'),
		// 'size' => 15,
		// 'name' => 'Verdana'
	)
);
$leaveEarlyStyle = array( // 早退
	'font' => array(
		'bold' => true,
		'color' => array('rgb' => 'FF00FF'),
		// 'size' => 15,
		// 'name' => 'Verdana'
	)
);

$year  = isset($_POST['year'])  ? trim($_POST['year'])  : date('Y',$runTimeStart);;
$month = isset($_POST['month']) ? trim($_POST['month']) : date('m',$runTimeStart)-1;
$title = isset($_POST['title']) ? trim($_POST['title']) : '考勤表';
$staff = isset($_POST['addStaff']) ? trim($_POST['addStaff']) : '';
$staff = preg_replace('/\s+/','#', $staff);
$staff = explode('#', $staff);

$time = strtotime($year.'-'.$month.'-1');
$title = date('Y年m月',$time).'_'.$title;
$xlsName = $title.'.xls';
// $dataFile = 'rk.xls';
$dateStart = strtotime(date('Y-m',$time).'-1 00:00');
$dateEnd   = strtotime(date('Y-m',$time).'-'.date('t',$time).' 23:59:59');

# 上传源数据
include('./upfile.class.php');
$up = new upfile("upload");
$dataFile00 = $up->upload('file00');
if ($up->error){
	$msg = '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
	员工信息文件上传失败：' . $up->error . '<a href="javascript:history.back();">[返回]</a>';
	exit($msg);
}
$dataFile01 = $up->upload('file01');
if ($up->error){
	$msg = '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
	中心源文件上传失败：' . $up->error . '<a href="javascript:history.back();">[返回]</a>';
	exit($msg);
}
$dataFile02 = $up->upload('file02');
if ($up->error){
	$msg = '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
	科大源文件上传失败：' . $up->error . '<a href="javascript:history.back();">[返回]</a>';
	exit($msg);
}
$dataFile03 = $up->upload('file03');
if ($up->error){
	$msg = '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
	项目源文件上传失败：' . $up->error . '<a href="javascript:history.back();">[返回]</a>';
	exit($msg);
}
// 累计休的表
$existUnRestDayFile = 0; // 存在《累计休》表
if(!empty($_FILES['unRestDay']['name'])){
	$unRestDayFile = $up->upload('unRestDay');
	if ($up->error){
		$msg = '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
		累计休文件上传失败：' . $up->error . '<a href="javascript:history.back();">[返回]</a>';
		exit($msg);
	}
	$existUnRestDayFile = 1;
}

// 累计休的表
if($existUnRestDayFile){
	$unRestDay = array();
	$reader = PHPExcel_IOFactory::createReader(PHPExcel_IOFactory::identify($unRestDayFile));
	$unRestDaySheet = $reader->load($unRestDayFile)->getSheet(0); // 读取第一個工作表
	$unRestDaySheetTotalRow = $unRestDaySheet->getHighestRow(); // 取得总行数
	$unRestDaySheetTotalCol = $unRestDaySheet->getHighestColumn(); // 取得总列数
	$unRestDaySheetTotalColIndex = PHPExcel_Cell::columnIndexFromString($unRestDaySheetTotalCol);
	for($row = 4; $row < $unRestDaySheetTotalRow; $row+=2){
		$name  = $unRestDaySheet->getCellByColumnAndRow(0,$row)->getValue();
		for($i=$unRestDaySheetTotalColIndex;$i>0;$i--){
			$value = $unRestDaySheet->getCellByColumnAndRow($i-1,$row)->getValue();
			if(is_numeric($value)) break;
		}
		if(!empty($name)) $unRestDay[$name] = $value;
	}
	// echo $unRestDaySheetTotalCol;
	// echo '<'.'pre>';
	// print_r($unRestDay);
	// exit;
}

# 写入
// xls文件信息
$objPHPExcel = new PHPExcel();
$objPHPExcel->getProperties()
	->setCreator("upall(root@upall.cn)")
	->setLastModifiedBy("root@upall.cn")
	->setTitle($title)
	->setSubject($title);

$objPHPExcel->getDefaultStyle()->getFont()->setName('微软雅黑');
$objPHPExcel->getDefaultStyle()->getFont()->setSize(10);

# 第一张表
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->setTitle('考勤表')
	->getDefaultRowDimension()->setRowHeight(20); // 默认行高
# 第二张表
$objPHPExcel->createSheet();
$objPHPExcel->setActiveSheetIndex(1);
$objPHPExcel->getActiveSheet()->setTitle('原始数据')
	->getDefaultRowDimension()->setRowHeight(20); // 默认行高
# 第三张表
$objPHPExcel->createSheet();
$objPHPExcel->setActiveSheetIndex(2);
$objPHPExcel->getActiveSheet()->setTitle('程序调试')
	->getDefaultRowDimension()->setRowHeight(20); // 默认行高


/**

 */
// tab0:
// goto tab1;
// 第一张表的内容（sheet01）
# thead 部分
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->freezePane('C4'); // 冻结窗格

$day = 1;
$totalDay = date('t',$time); // 当月天数
$iBegin = PHPExcel_Cell::columnIndexFromString('A')-1;
$iEnd   = $totalDay + 15 -1;
$endCol = PHPExcel_Cell::stringFromColumnIndex($iEnd);
$week = explode(' ', '日 一 二 三 四 五 六');
$weekStart = date('w',strtotime(date('Y-m-1 01:00:00',$time)));
$saturdayCount = $sundayCount = 0;
$monday = array(); // 周一的天数
for($i = $iBegin; $i <= $iEnd; $i++){
	$col = PHPExcel_Cell::stringFromColumnIndex($i);
	$objPHPExcel->getActiveSheet()->getStyle($col)->applyFromArray($tdStyle);
	for($j=1; $j <= 3; $j++){
		$objPHPExcel->getActiveSheet()->getStyle($col.$j)->applyFromArray($thStyle);
	}
	// 背景色
	$objPHPExcel->getActiveSheet()->getStyle($col.'2:'.$col.'3')
		->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$objPHPExcel->getActiveSheet()->getStyle($col.'2:'.$col.'3')
		->getFill()->getStartColor()->setARGB("FFCCFFFF");
	if($i >= 2 && $day <= $totalDay) {
		// 第N天
		$objPHPExcel->getActiveSheet()->setCellValue($col.'2', $day);
		// 星期N
		$objPHPExcel->getActiveSheet()->setCellValue($col.'3', $week[$weekStart]);
		if('六' == $week[$weekStart]) $saturdayCount++;
		if('日' == $week[$weekStart]) $sundayCount++;
		if('一' == $week[$weekStart]) $monday[] = $day; // 用于判断周一是否迟到
		$weekStart++;
		if($weekStart > 6) $weekStart = 0;
		// 列宽
		$objPHPExcel->getActiveSheet()->getColumnDimension($col)->setWidth(4);
		$day++;
	}
}

$objPHPExcel->getActiveSheet()->mergeCells('A1:'.$endCol.'1')->setCellValue('A1', $title);
$objPHPExcel->getActiveSheet()->getStyle('A1')->getFont()->setSize(20);
$objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(30);

$objPHPExcel->getActiveSheet()->mergeCells('A2:A3')->setCellValue('A2', '姓名');
$objPHPExcel->getActiveSheet()->setCellValue('B2', '日期');
$objPHPExcel->getActiveSheet()->setCellValue('B3', '星期');

$index = 0;
$addonField = explode(' ','迟到(分) 早退 旷工 未打卡 实际出勤 事假 有薪假 加班 上月累计休 本月应休 本月实休 补休 下月累计休');
$iBegin = $totalDay + 2;
$iEnd   = $iBegin + count($addonField) -1;
for($i = $iBegin; $i <= $iEnd; $i++){
	$col = PHPExcel_Cell::stringFromColumnIndex($i);
	$objPHPExcel->getActiveSheet()->setCellValue($col.'2', $addonField[$index]);
	$index++;
	$objPHPExcel->getActiveSheet()->mergeCells($col.'2:'.$col.'3');
}

# end
